#include <iostream>
using namespace std;
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <fstream>
#include <string>
#include <vector>
#include <map>
#include <set>

int n, m;

struct student_record{
    int age, didp;
    string sid;
};

struct course_record{
    string cid, name;
};

struct teacher_record{
    int age, didp;
    string tid;
};

struct grade_record{
    int sidp, cidp;
    int score;
};

struct teach_record{
    int cidp, tidp;
};

vector<student_record> student;
vector<course_record> course;
vector<teacher_record> teacher;
vector<grade_record> grade;
vector<teach_record> teach;

map<string, int> sid_map, cid_map, tid_map, dept_map;

vector<string> dept =   {"Philosophy", "Literary", "History", "Arts", "Journalism", "Economics", "Sociology", "infoRM",
                        "Education", "Finance", "Statistics", "Business", "LaborHR", "Hanqing", "Law", "Marxism", "envi",
                        "info", "Physics", "Chemistry", "Psychology"};

vector<string> tricky_id = {"4936","04936","004936","0","00","000","0000","00000","000000","0000000","00000000","000000000","0000000000"};
vector<string> tricky_name = {"SELECT", "sid", "name", "FROM", "WHERE", "AND", "Philosophy", "Literary", "History", "Arts","AND","AND","name"};

string gen_id(int i)
{
    if(i<tricky_id.size() && i>=0) return tricky_id[i];
    int len = (rand() % 10) + 1;
    string gid;
    for(int i=0; i<len; i++)
    {
        char ch = '0' + (rand() % 10);
        gid.push_back(ch);
    }
    return gid;
}

string gen_str(int i)
{
    if(i<tricky_name.size() && i>=0) return tricky_name[i];
    int len = (rand() % 10) + 1;
    string gstr;
    for(int i=0; i<len; i++)
    {
        char ch;
        if(rand()%2==0) ch = 'a' + (rand() % 26);
        else ch = 'A' + (rand() % 26);
        gstr.push_back(ch);
    }
    return gstr;
}

void gen_table()
{
    student.resize(n);
    for(int i=0; i<n; i++)
    {
        string stu_id = gen_id(i);
        if(sid_map.count(stu_id)>0) {i--; continue;}
        sid_map[stu_id] = i;
        student[i].sid = stu_id;
        student[i].age = rand() % 101;
        student[i].didp = rand() % dept.size();
    }

    course.resize(n);
    for(int i=0; i<n; i++)
    {
        string course_id = gen_id(i);
        if(cid_map.count(course_id)>0) {i--; continue;}
        cid_map[course_id] = i;
        course[i].cid = course_id;
        course[i].name = gen_str(i);
    }

    teacher.resize(n);
    for(int i=0; i<n; i++)
    {
        string tea_id = gen_id(i);
        if(tid_map.count(tea_id)>0) {i--; continue;}
        tid_map[tea_id] = i;
        teacher[i].tid = tea_id;
        teacher[i].age = rand() % 101;
        teacher[i].didp = rand() % dept.size();
    }

    set<int> flag;
    grade.resize(n);
    for(int i=0; i<n; i++)
    {
        int a = rand() % n;
        int b = rand() % n;
        int c = a * n + b;
        if(flag.count(c)==1) {i--; continue;}
        flag.insert(c);
        grade[i].cidp = a;
        grade[i].sidp = b;
        grade[i].score = rand() % 101;
    }

    flag.clear();
    teach.resize(n);
    for(int i=0; i<n; i++)
    {
        int a = rand() % n;
        int b = rand() % n;
        int c = a * n + b;
        if(flag.count(c)==1) {i--; continue;}
        flag.insert(c);
        teach[i].cidp = a;
        teach[i].tidp = b;
    }
}

void print_table()
{
    cout << n << endl;
    for(int i=0; i<n; i++)
    {
        cout << student[i].sid << ' ' << dept[student[i].didp] << ' ' << student[i].age << endl;
    }
    cout << n << endl;
    for(int i=0; i<n; i++)
    {
        cout << course[i].cid << ' ' << course[i].name << endl;
    }
    cout << n << endl;
    for(int i=0; i<n; i++)
    {
        cout << teacher[i].tid << ' ' << dept[teacher[i].didp] << ' ' << teacher[i].age << endl;
    }
    cout << n << endl;
    for(int i=0; i<n; i++)
    {
        cout << student[grade[i].sidp].sid << ' ' << course[grade[i].cidp].cid << ' ' << grade[i].score << endl;
    }
    cout << n << endl;
    for(int i=0; i<n; i++)
    {
        cout << course[teach[i].cidp].cid << ' ' << teacher[teach[i].tidp].tid << endl;
    }
}

void init_dept()
{
    for(int i=0; i<dept.size(); i++)
    {
        dept_map[dept[i]] = 1;
    }
    while(dept.size()<2*n)
    {
        string tmp = gen_str(999);
        if(dept_map.count(tmp)==0)
        {
            dept_map[tmp] = 1;
            dept.push_back(tmp);
        }
    }
}

void check()
{
    int dept_num = dept.size();
    //cerr << "|dept| = " << dept_num << endl;
    for(int i=0; i<dept_num; i++)
        if(dept[i].length()>10)  cerr << "dept len > 10" << endl;
    for(int i=0; i<dept_num; i++)
        for(int j=i+1; j<dept_num; j++)
            if(dept[i]==dept[j])
    {
        cerr << "duplicate dept" << endl;
        exit(0);
    }
    cerr << "|dept| = " << dept.size() << endl;
    cerr << "No Duplicate depts" << endl;
}

void print_sql()
{
    cout << m << endl;
    cout << "SELECT * FROM Grade" << endl;
    cout << "SELECT * FROM Student WHERE sid = \"000\"" << endl;
    cout << "SELECT * FROM Teacher WHERE Teacher  .  dept = \"NULL\"" << endl;
    cout << "SELECT dept,Teacher. dept, dept,tid FROM Teacher WHERE age <80 AND Teacher.age>35 AND age < 100" << endl;

    cout << "SELECT sid, Teach.cid FROM Teach,Grade WHERE score>86 AND Grade.cid = Teach.cid AND score < 90" << endl; // check size

    cout << "SELECT * FROM Teacher,Student WHERE Teacher.dept=Student.dept AND Student.age>3 AND Teacher.age>8" << endl; // check size

    cout << "SELECT name,score FROM Course,Grade WHERE name=\"Arts\" AND Grade.score>60 AND Course.cid=Grade.cid" << endl;
    cout << "SELECT Grade.cid, name, score FROM Course,Grade WHERE Course.cid=Grade.cid" << endl;
    cout << "SELECT * FROM Grade, Student WHERE Student.sid=Grade.sid" << endl;
    cout << "SELECT * FROM Grade, Student WHERE Student.sid=Grade.sid AND Student.sid=\"04936\"" << endl;
}

void print_age_info()
{
    int age_num[101] = {0};
    for(int i=0; i<n; i++)
    {
        age_num[student[i].age]++;
    }
    for(int i=0; i<101; i++)
    {
        cout << i <<":\t" << age_num[i] << endl;
    }

}

int main()
{
    srand((unsigned)time(NULL));
    n = 10000;
    m = 10;
    init_dept();
    //check();
    gen_table();
    print_table();
    print_sql();
    //print_age_info();
    return 0;
}
