#include <iostream>
using namespace std;
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <fstream>
#include <string>
#include <vector>
#include <map>
#include <set>

int n, m;

struct student_record{
    int age;
    string sid, dept;
};

struct course_record{
    string cid, name;
};

struct teacher_record{
    int age;
    string tid, dept;
};

struct grade_record{
    string sid, cid;
    int score;
};

struct teach_record{
    string cid, tid;
};

vector<student_record> student;
vector<course_record> course;
vector<teacher_record> teacher;
vector<grade_record> grade;
vector<teach_record> teach;

vector<int> ans_num;

void read_tables()
{
    cin >> n;
    student.resize(n);
    for(int i=0; i<n; i++)
        cin >> student[i].sid >> student[i].dept >> student[i].age;

    cin >> n;
    course.resize(n);
    for(int i=0; i<n; i++)
        cin >> course[i].cid >> course[i].name;

    cin >> n;
    teacher.resize(n);
    for(int i=0; i<n; i++)
        cin >> teacher[i].tid >> teacher[i].dept >> teacher[i].age;

    cin >> n;
    grade.resize(n);
    for(int i=0; i<n; i++)
        cin >> grade[i].sid >> grade[i].cid >> grade[i].score;

    cin >> n;
    teach.resize(n);
    for(int i=0; i<n; i++)
        cin >> teach[i].cid >> teach[i].tid;
}

void read_queries()
{
    cin >> m;
    ans_num.resize(m,0);

    /*

    Generate standard answer in a tricky way.
    Code for each SQL query directly.
    Therefore, we need not read queries here.

    */
}

void solve_1()
{
    //SELECT * FROM Grade
    for(int i=0; i<n; i++)
    {
        cout << grade[i].sid << ' ' << grade[i].cid << ' ' << grade[i].score << endl;
    }
}

void solve_2()
{
    //SELECT * FROM Student WHERE sid = "000"
    for(int i=0; i<n; i++)
        if(student[i].sid=="000")
    {
        cout << student[i].sid << ' ' << student[i].dept << ' ' << student[i].age << endl;
    }
}

void solve_3()
{
    //SELECT * FROM Teacher WHERE Teacher  .  dept = "NULL"
    for(int i=0; i<n; i++)
        if(teacher[i].dept=="NULL")
    {
        cout << teacher[i].tid << ' ' << teacher[i].dept << ' ' << teacher[i].age << endl;
    }
}

void solve_4()
{
    //SELECT dept,Teacher. dept, dept,tid FROM Teacher WHERE age <80 AND Teacher.age>35 AND age < 100
    for(int i=0; i<n; i++)
        if(teacher[i].age<80 && teacher[i].age>35 && teacher[i].age<100)
    {
        cout << teacher[i].dept << ' ' << teacher[i].dept << ' ' << teacher[i].dept << ' ' << teacher[i].tid << endl;
    }
}

bool check_key()
{
    set<string> flag;
    for(int i=0; i<n; i++)
    {
        string str = student[i].sid;
        if(flag.count(str)>0) return false;
        flag.insert(str);
    }
    flag.clear();
    for(int i=0; i<n; i++)
    {
        string str = course[i].cid;
        if(flag.count(str)>0) return false;
        flag.insert(str);
    }
    flag.clear();
    for(int i=0; i<n; i++)
    {
        string str = teacher[i].tid;
        if(flag.count(str)>0) return false;
        flag.insert(str);
    }
    flag.clear();

    set<pair<string,string>> flag2;
    for(int i=0; i<n; i++)
    {
        string str1 = grade[i].sid;
        string str2 = grade[i].cid;
        if(flag2.count(pair<string,string>(str1,str2))>0) return false;
        flag2.insert(pair<string,string>(str1,str2));
    }
    flag2.clear();
    for(int i=0; i<n; i++)
    {
        string str1 = teach[i].cid;
        string str2 = teach[i].tid;
        if(flag2.count(pair<string,string>(str1,str2))>0) return false;
        flag2.insert(pair<string,string>(str1,str2));
    }
    flag2.clear();

    return true;
}

bool check_int(int i)
{
    if(i<0 || i>100) return false;
    return true;
}

bool check_istr(string istr)
{
    if(istr.length()==0 || istr.length()>10) return false;
    for(int i=0; i<istr.length(); i++)
        if(istr[i]<'0' || istr[i]>'9') return false;
    return true;
}

bool check_cstr(string cstr)
{
    if(cstr.length()==0 || cstr.length()>10) return false;
    for(int i=0; i<cstr.length(); i++)
        if((cstr[i]<'a' || cstr[i]>'z') && (cstr[i]<'A' || cstr[i]>'Z')) return false;
    return true;
}

void check()
{
    bool ok;
    for(int i=0; i<n; i++)
    {
        ok = check_istr(student[i].sid) && check_cstr(student[i].dept) && check_int(student[i].age);
        ok = ok && check_istr(course[i].cid) && check_cstr(course[i].name);
        ok = ok && check_istr(teacher[i].tid) && check_cstr(teacher[i].dept) && check_int(teacher[i].age);
        ok = ok && check_istr(grade[i].sid) && check_istr(grade[i].cid) && check_int(grade[i].score);
        ok = ok && check_istr(teach[i].cid) && check_istr(teach[i].tid);
        if(!ok) break;
    }
    ok = ok && check_key();
    if(!ok)
    {
        cerr << "Format Error" << endl;
        exit(0);
    }
}


int main(int argc, char*argv[])
{
    read_tables();
    read_queries();
    check();
    switch(argv[1][0])
    {
    case 'a':
        solve_1();
        break;
    case 'b':
        solve_2();
        break;
    case 'c':
        solve_3();
        break;
    case 'd':
        solve_4();
        break;
    default:
        cerr << "Wrong arg" << endl;
        exit(0);
    }
    return 0;
}
