#include <iostream>
using namespace std;
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <fstream>
#include <string>
#include <vector>
#include <map>
#include <set>

int n, m;

struct student_record{
    int age;
    string sid, dept;
};

struct course_record{
    string cid, name;
};

struct teacher_record{
    int age;
    string tid, dept;
};

struct grade_record{
    string sid, cid;
    int score;
};

struct teach_record{
    string cid, tid;
};

vector<student_record> student;
vector<course_record> course;
vector<teacher_record> teacher;
vector<grade_record> grade;
vector<teach_record> teach;

vector<int> ans_num;

void read_tables()
{
    cin >> n;
    student.resize(n);
    for(int i=0; i<n; i++)
        cin >> student[i].sid >> student[i].dept >> student[i].age;

    cin >> n;
    course.resize(n);
    for(int i=0; i<n; i++)
        cin >> course[i].cid >> course[i].name;

    cin >> n;
    teacher.resize(n);
    for(int i=0; i<n; i++)
        cin >> teacher[i].tid >> teacher[i].dept >> teacher[i].age;

    cin >> n;
    grade.resize(n);
    for(int i=0; i<n; i++)
        cin >> grade[i].sid >> grade[i].cid >> grade[i].score;

    cin >> n;
    teach.resize(n);
    for(int i=0; i<n; i++)
        cin >> teach[i].cid >> teach[i].tid;
}

void read_queries()
{
    cin >> m;
    ans_num.resize(m,0);

    /*

    Generate standard answer in a tricky way.
    Code for each SQL query directly.
    Therefore, we need not read queries here.

    */
}


void solve_1()
{
    //SELECT * FROM Grade
    for(int i=0; i<n; i++)
    {
        cout << grade[i].sid << ' ' << grade[i].cid << ' ' << grade[i].score << endl;
    }
}

void solve_2()
{
    //SELECT * FROM Student WHERE sid = "000"
    for(int i=0; i<n; i++)
        if(student[i].sid=="000")
    {
        cout << student[i].sid << ' ' << student[i].dept << ' ' << student[i].age << endl;
    }
}

void solve_3()
{
    //SELECT * FROM Teacher WHERE Teacher  .  dept = "NULL"
    for(int i=0; i<n; i++)
        if(teacher[i].dept=="NULL")
    {
        cout << teacher[i].tid << ' ' << teacher[i].dept << ' ' << teacher[i].age << endl;
    }
}

void solve_4()
{
    //SELECT dept,Teacher. dept, dept,tid FROM Teacher WHERE age <80 AND Teacher.age>35 AND age < 100
    for(int i=0; i<n; i++)
        if(teacher[i].age<80 && teacher[i].age>35 && teacher[i].age<100)
    {
        cout << teacher[i].dept << ' ' << teacher[i].dept << ' ' << teacher[i].dept << ' ' << teacher[i].tid << endl;
    }
}

void solve()
{
    /*

    SELECT * FROM Grade
    SELECT * FROM Student WHERE sid = "000"
    SELECT * FROM Teacher WHERE Teacher  .  dept = "NULL"
    SELECT dept,Teacher. dept, dept,tid FROM Teacher WHERE age <80 AND Teacher.age>35 AND age < 100

    SELECT * FROM Teach,Grade
    SELECT sid, Teach.cid, Grade.cid, tid FROM Teach,Grade WHERE Grade.cid = Teach.cid
    SELECT * FROM Teacher, Student WHERE Teacher .dept=Student.dept
    SELECT * FROM Teacher , Student WHERE Teacher . age=Student.age
    SELECT * FROM Teacher ,Student WHERE Teacher . dept=Student.dept AND Student.dept = "Law"
    SELECT name,score FROM Course,Grade WHERE name="Arts" AND Grade.score>60 AND Course.cid=Grade.cid

    */

    solve_1();
    solve_2();
    solve_3();
    solve_4();

    int mi = 4;

    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++)
        {
            ans_num[mi]++;
            cout << teach[i].cid << ' ' << teach[i].tid << ' ';
            cout << grade[j].sid << ' ' << grade[j].cid << ' ' << grade[j].score << endl;
        }
    mi++;

    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++)
            if(teach[i].cid==grade[j].cid)
        {
            ans_num[mi]++;
            cout << grade[j].sid << ' ' << teach[i].cid << ' ' << grade[j].cid << ' ' << teach[i].tid << endl;
        }
    mi++;

    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++)
            if(teacher[i].dept==student[j].dept)
    {
        ans_num[mi]++;
        cout << teacher[i].tid << ' ' << teacher[i].dept << ' ' << teacher[i].age << ' ';
        cout << student[j].sid << ' ' << student[j].dept << ' ' << student[j].age << endl;
    }
    mi++;

    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++)
            if(teacher[i].age==student[j].age)
    {
        ans_num[mi]++;
        cout << teacher[i].tid << ' ' << teacher[i].dept << ' ' << teacher[i].age << ' ';
        cout << student[j].sid << ' ' << student[j].dept << ' ' << student[j].age << endl;
    }
    mi++;

    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++)
            if(teacher[i].dept==student[j].dept && student[j].dept=="Law")
    {
        ans_num[mi]++;
        cout << teacher[i].tid << ' ' << teacher[i].dept << ' ' << teacher[i].age << ' ';
        cout << student[j].sid << ' ' << student[j].dept << ' ' << student[j].age << endl;
    }
    mi++;


    for(int i=0; i<n; i++)
        if(course[i].name=="Arts")
            for(int j=0; j<n; j++)
                if(grade[j].score>60 && course[i].cid==grade[j].cid)
    {
        ans_num[mi]++;
        cout << course[i].name << ' ' << grade[j].score << endl;
    }
    mi++;
}

bool check_key()
{
    set<string> flag;
    for(int i=0; i<n; i++)
    {
        string str = student[i].sid;
        if(flag.count(str)>0) return false;
        flag.insert(str);
    }
    flag.clear();
    for(int i=0; i<n; i++)
    {
        string str = course[i].cid;
        if(flag.count(str)>0) return false;
        flag.insert(str);
    }
    flag.clear();
    for(int i=0; i<n; i++)
    {
        string str = teacher[i].tid;
        if(flag.count(str)>0) return false;
        flag.insert(str);
    }
    flag.clear();

    set<pair<string,string>> flag2;
    for(int i=0; i<n; i++)
    {
        string str1 = grade[i].sid;
        string str2 = grade[i].cid;
        if(flag2.count(pair<string,string>(str1,str2))>0) return false;
        flag2.insert(pair<string,string>(str1,str2));
    }
    flag2.clear();
    for(int i=0; i<n; i++)
    {
        string str1 = teach[i].cid;
        string str2 = teach[i].tid;
        if(flag2.count(pair<string,string>(str1,str2))>0) return false;
        flag2.insert(pair<string,string>(str1,str2));
    }
    flag2.clear();

    return true;
}

bool check_int(int i)
{
    if(i<0 || i>100) return false;
    return true;
}

bool check_istr(string istr)
{
    if(istr.length()==0 || istr.length()>10) return false;
    for(int i=0; i<istr.length(); i++)
        if(istr[i]<'0' || istr[i]>'9') return false;
    return true;
}

bool check_cstr(string cstr)
{
    if(cstr.length()==0 || cstr.length()>10) return false;
    for(int i=0; i<cstr.length(); i++)
        if((cstr[i]<'a' || cstr[i]>'z') && (cstr[i]<'A' || cstr[i]>'Z')) return false;
    return true;
}

void check()
{
    bool ok;
    for(int i=0; i<n; i++)
    {
        ok = check_istr(student[i].sid) && check_cstr(student[i].dept) && check_int(student[i].age);
        ok = ok && check_istr(course[i].cid) && check_cstr(course[i].name);
        ok = ok && check_istr(teacher[i].tid) && check_cstr(teacher[i].dept) && check_int(teacher[i].age);
        ok = ok && check_istr(grade[i].sid) && check_istr(grade[i].cid) && check_int(grade[i].score);
        ok = ok && check_istr(teach[i].cid) && check_istr(teach[i].tid);
        if(!ok) break;
    }
    ok = ok && check_key();
    if(!ok)
    {
        cerr << "Format Error" << endl;
        exit(0);
    }
}


int main()
{
    read_tables();
    read_queries();
    check();
    solve();
    for(int i=0; i<m; i++)
    {
        cerr << ans_num[i] << ' ';
    }
    cerr << endl;
    for(int i=0; i<m; i++)
        if(ans_num[i]>10000)
    {
        cerr << "Answer Size Error: " << i << '\t' << ans_num[i] << endl;
    }
    return 0;
}
